    #This script was created by Adam Beazley for public use and may be edited.
    #http://www.abeazleydesign.com
    #Modified by Joshua Driggs (zapwizard at gmail.com)

    #Directions
    #Just click in the Import Materials button in the plugins menue and type in the location of all of you image files.
    #This script will create a material and name it the same name as the image file and then use that file as the texture.
    #all textures will come in at a standard scale and must be edited later
    #after all materials and textures have been imported into the model, simply add them to your library
    #you can then save the library as a .skm library file through sketchup.
    #have fun!!!
    #
    ### V2.0 ZapWizard 29/07/09 Modified for importing Left4Dead textures.
    ### v1.1 TIG tweaks 29/12/05 ###
    #-----------------------------------------------------------------------------
    require 'sketchup.rb'
    #-----------------------------------------------------------------------------

module SU_Source_tools_mats
    def SU_Source_tools_mats.materialimporter
       model= Sketchup.active_model ## Set to our current working model
       materials= model.materials  ## get list of current materials
       model.materials.current = nil ##set current material to default.
       model.materials.purge_unused  ##Purge current materials from file
       model.start_operation ("Import Materials") ###undo - see commit at end
       pwd= Dir.getwd.split("/").join+"\\" ### fix for SU
       ## Set working directory
       if $dryroot == false ##Check if root directory has been set this session.
          showinfo = UI.messagebox "Left4Dead texture importing script by ZapWizard
          
    Due to the way SketchUp works you can't save a whole material library from a RUBY script. So the first time you run this script you will see this message followed by a open file window.
       
    You must select the ROOT folder for your images. This is typically \\materials for Left4Dead. Due to the way SketchUp loads the files, you must choose a file inside the \\materials folder, not the folder itself.

    The easy way to do this is to place a simple text file in \\materials and select that.", MB_OK
          $dryroot= UI.openpanel "Choose the ROOT directory for your textures.", pwd , "*.???"   ### for jpg or png
          $dryroot= File.dirname($dryroot) ##Current working directory
          return nil if not $dryroot
          showinfo = UI.messagebox "
    Now in the next window pick the sub-folder you wish to import images from.

    For example \\materials\\bricks. All future windows will use the previously set user window.
    If all goes well your -In Model- material list should fill up with materials, with the correct in-game names.

    You will also no longer see these text prompts until you re-start SketchUp. To reset the root folder choose it from the plugins menu", MB_OK
       end
       dry= UI.openpanel "To Pick choose the Directory with your image files", pwd , "*.???"   ### for jpg or png
       return nil if not dry
       dry= File.dirname(dry) ##Current working directory
       return nil if not dry
       images= Dir["*.{jpg,png,tif,bmp,gif,tga,epx}"]### for all supported image file types
     
       for image in images

       #Subtract ROOT folder from Current Directory and set as sub name
       rootfolder = String.new($dryroot.reverse)
       #puts "Root folder: "<<rootfolder ##current working folder "\materials"
       folder = String.new(dry.reverse)
       #puts "Working folder: "<<folder ##current working folder "\materials\brick"
       subfolder = folder.chomp(rootfolder)
       subfolder = subfolder.chop
       subfolder = subfolder.reverse
       subfolder = subfolder.tr("\\", "/")
       ##replace any backslashes with forward slashes
       
       #puts "Sub folder: "<<subfolder2 ##current sub folder "brick"
         imgname = subfolder<<"/"<<image.split(".")[0..-2].join(".") ### removes .jpg etc from end
         puts imgname
         mat= materials.add imgname
         mat.texture = image
         size = mat.texture.size = 128 ### Sets the default material size to 128"
       end
    if $stopshow == false
    showinfo = UI.messagebox "Texures imported.

    Check your -In Model- texture category and save them as a collection.

    Press cancel to prevent this message from showing again.", MB_OKCANCEL
       if showinfo == 2 #cancel
          $stopshow = true
       end
    end

       model.commit_operation ###undo all if needed
    end #def###

    def SU_Source_tools_mats.resetdryroot
    $dryroot = false
    $stopshow = false
    materialimporter
    end
end
	
    #-----------------------------------------------------------------------------
	if !file_loaded?('source_sutools') then
		$source_sutools_menu = UI.menu("Plugins").add_submenu("* Source SU Tools *")
	end
	if !file_loaded?(__FILE__) then
		$source_sutools_menu.add_item("L4D Import textures") { SU_Source_tools_mats.materialimporter  }
		$source_sutools_menu.add_item("L4D -Reset Root Folder") { SU_Source_tools_mats.resetdryroot }
	end
	$dryroot = false
    #
file_loaded('source_sutools')
file_loaded(__FILE__)














